
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.catalogClient.z3950.drivers;
import es.gva.cit.catalogClient.drivers.AbstractCatalogServiceDriver;
import es.gva.cit.catalogClient.metadataXML.XMLNode;
import es.gva.cit.catalogClient.metadataXML.XMLTree;
import es.gva.cit.catalogClient.protocols.Z3950Protocol;
import es.gva.cit.catalogClient.querys.Query;
import java.io.ByteArrayInputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;

/**
 * This class implements the Z39.50 protocol.
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 * @see http://www.loc.gov/z3950/agency/
 */
public class Z3950CatalogServiceDriver extends AbstractCatalogServiceDriver {
/* (non-Javadoc)
     * @see ICatalogServerDriver#GetCapabilities(java.lang.String, java.lang.String)
     */

/**
 * 
 * 
 * 
 * @return 
 * @param url 
 */
    public Collection getCapabilities(URL url) {        
        Collection nodes = new ArrayList();;
        Z3950Messages messages = new Z3950Messages(this);
        String message = messages.getCapabilities(new Z3950Protocol().openConnection(
                    url));
        ByteArrayInputStream buffer = new ByteArrayInputStream(message.getBytes());
        nodes.add(XMLTree.xmlToTree(buffer));
        return nodes;
    } 
/* (non-Javadoc)
     * @see ICatalogServerDriver#GetRecords(java.lang.String, java.lang.String, java.lang.String, int, int, java.lang.String, java.lang.String)
     */

/**
 * 
 * 
 * 
 * @return 
 * @param url 
 * @param query 
 * @param firstRecord 
 */
    public Collection getRecords(URL url, Query query, int firstRecord) {        
        Collection nodes = new java.util.ArrayList();
        setQuery(query);
        Z3950Messages messages = new Z3950Messages(this);
        
        String message = messages.getRecords(getQuery(),Z3950Protocol.getDatabase(url));
        System.out.println(message);
        nodes = new Z3950Protocol().doQuery(url, message, firstRecord);
        return nodes;
    } 
/* (non-Javadoc)
     * @see catalogClient.ICatalogServerDriver#setParameters(java.util.Properties)
     */

/**
 * 
 * 
 * 
 * @return 
 * @param nodes 
 * @param url 
 */
    public boolean setParameters(Collection nodes, URL url) {        
        // TODO Auto-generated method stub
        setServerAnswerReady(XMLTree.searchNodeValue((XMLNode)nodes.toArray()[0], "Servidor"));
        return true;
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.drivers.ICatalogServiveDriver#isTheProtocol(java.net.URL)
     */

/**
 * 
 * 
 * 
 * @return 
 * @param url 
 */
    public boolean isProtocolSupported(URL url) {        
        return new Z3950Protocol().isProtocolSupported(url);
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.drivers.ICatalogServiceDriver#getServerPofile()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public String getQueryProfile() {        
        // TODO Auto-generated method stub
        return "Z3950";
    } 
 }
