/*
 * Created on 04-mar-2005
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.drivers.jdbc.mysql;

import java.awt.geom.Rectangle2D;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.log4j.Logger;

import com.hardcode.gdbms.engine.data.edition.DataWare;
import com.iver.andami.messages.NotificationManager;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.SqlDriveExceptionType;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.drivers.DBLayerDefinition;
import com.iver.cit.gvsig.fmap.drivers.DefaultDBDriver;
import com.iver.cit.gvsig.fmap.drivers.DriverAttributes;
import com.iver.cit.gvsig.fmap.drivers.IFeatureIterator;
import com.iver.cit.gvsig.fmap.drivers.WKBParser2;

/**
 * @author FJP
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public class MySQLDriver extends DefaultDBDriver {
	private static Logger logger = Logger
			.getLogger(MySQLDriver.class.getName());

	private WKBParser2 parser = new WKBParser2();

	// private WKTParser wktParser = new WKTParser();

	/*
	 * private int fetch_min=-1; private int fetch_max=-1;
	 */
	private Statement st;

	private String strAux;

	private String strEPSG = "-1";

	private String originalEPSG;

	private String completeWhere;

	/**
	 * Don't have information about working area
	 */
	private String sqlOrig;

	/**
	 * Does have information about working area and order
	 */
	private String sqlTotal;

	/**
	 *
	 */
	public MySQLDriver() {
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.drivers.VectorialDriver#getDriverAttributes()
	 */
	public DriverAttributes getDriverAttributes() {
		return null;
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.hardcode.driverManager.Driver#getName()
	 */
	public String getName() {
		return "mySQL JDBC Driver";
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.layers.ReadableVectorial#getShape(int)
	 */
	public IGeometry getShape(int index) {
		IGeometry geom = null;
		boolean resul;
		try {
			if (rs != null) {
				rs.absolute(index + 1);
				byte[] data = rs.getBytes(1);
				geom = parser.parse(data);
			}

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return geom;
	}

	/**
	 * @param conn
	 */
	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.drivers.VectorialJDBCDriver#setData(java.sql.Connection,
	 *      java.lang.String, java.lang.String, java.lang.String, int)
	 */
	public void setData(Connection conn, DBLayerDefinition lyrDef) {
		this.conn = conn;
		setLyrDef(lyrDef);
		try {

			// NO ESTA LISTO ESTO AUN EN mySQL, o no s usuarlo getTableEPSG();

			sqlOrig = "SELECT " + getTotalFields() + " FROM "
					+ getLyrDef().getTableName() + " ";
					// + getLyrDef().getWhereClause();
			completeWhere = getCompoundWhere(workingArea, strEPSG);
			String sqlAux = sqlOrig + completeWhere + " ORDER BY "
					+ getLyrDef().getFieldID();
			logger.info("Cadena SQL:" + sqlAux);
			sqlTotal = sqlAux;

			st = conn.createStatement(ResultSet.TYPE_FORWARD_ONLY,
					ResultSet.CONCUR_READ_ONLY);

			rs = st.executeQuery(sqlTotal);
			metaData = rs.getMetaData();
			// Le pegamos un primera pasada para poder relacionar
			// un campo de identificador nico (parecido al OID en
			// postgresql) con el ndice dentro del recordset.
			// Esto cuando haya ediciones, no es vlido, y hay
			// que refrescarlo.
			doRelateID_FID();

		} catch (SQLException e) {
			NotificationManager.addError(
					"Error al conectar a la base de datos.", e);
			e.printStackTrace();
		}
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.drivers.VectorialDatabaseDriver#getGeometryIterator(java.lang.String)
	 */
	public IFeatureIterator getFeatureIterator(String sql)
			throws com.iver.cit.gvsig.fmap.DriverException {
		Statement st;
		MySqlFeatureIterator geomIterator = null;
		try {
			logger.debug(sql);
			st = conn.createStatement();
			// st.setFetchSize(2000);
			ResultSet rs = st.executeQuery(sql);
			geomIterator = new MySqlFeatureIterator(rs);
			geomIterator.setLyrDef(getLyrDef());
		} catch (SQLException e) {
			e.printStackTrace();
			SqlDriveExceptionType type = new SqlDriveExceptionType();
            type.setDriverName("MySQL Driver");
            type.setSql(sql);
            type.setLayerName(getTableName());
            type.setSchema(null);
            throw new com.iver.cit.gvsig.fmap.DriverException(e, type);
//			throw new com.iver.cit.gvsig.fmap.DriverException(e);
		}

		return geomIterator;
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.drivers.VectorialDatabaseDriver#getGeometryIterator(java.awt.geom.Rectangle2D)
	 */
	public IFeatureIterator getFeatureIterator(Rectangle2D r, String strEPSG)
			throws DriverException {
		if (workingArea != null)
			r = r.createIntersection(workingArea);
		String sqlAux = sqlOrig + getCompoundWhere(r, strEPSG);

		return getFeatureIterator(sqlAux);
	}

	/**
	 * Le pasas el rectngulo que quieres pedir. La primera vez es el
	 * workingArea, y las siguientes una interseccion de este rectangulo con el
	 * workingArea
	 *
	 * @param r
	 * @param strEPSG
	 * @return
	 */
	private String getCompoundWhere(Rectangle2D r, String strEPSG) {
		if (r == null)
			return getWhereClause();

		double xMin = r.getMinX();
		double yMin = r.getMinY();
		double xMax = r.getMaxX();
		double yMax = r.getMaxY();

		String wktBox = "GeomFromText('LINESTRING(" + xMin + " " + yMin + ", "
				+ xMax + " " + yMin + ", " + xMax + " " + yMax + ", " + xMin
				+ " " + yMax + ")', " + strEPSG + ")";
		String sqlAux;
		if (getWhereClause().startsWith("WHERE"))
			sqlAux = getWhereClause() + " AND " +"MBRIntersects(" + wktBox + ", " + getLyrDef().getFieldGeometry() + ")";
		else
			sqlAux = "WHERE MBRIntersects(" + wktBox + ", " + getLyrDef().getFieldGeometry() + ")";
		return sqlAux;
	}

	public void open() {
		// TODO Auto-generated method stub

	}

	/**
	 * @see com.iver.cit.gvsig.fmap.drivers.VectorialDatabaseDriver#getConnectionStringBeginning()
	 */
	public String getConnectionStringBeginning() {
		return "jdbc:mysql:";
	}

	static {
		try {
			Class.forName("com.mysql.jdbc.Driver");
		} catch (ClassNotFoundException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.drivers.VectorialDatabaseDriver#getGeometryField(java.lang.String)
	 */
	public String getGeometryField(String fieldName) {
		return "ASBINARY(" + fieldName + ")";
	}

	/**
	 * @see com.hardcode.gdbms.engine.data.driver.ObjectDriver#getPrimaryKeys()
	 */
	public int[] getPrimaryKeys()
			throws com.hardcode.gdbms.engine.data.driver.DriverException {
		return new int[] { getLyrDef().getIdFieldID() - 2 };
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.drivers.VectorialJDBCDriver#getDefaultPort()
	 */
	public int getDefaultPort() {
		return 3306;
	}

	/**
	 * @see com.hardcode.gdbms.engine.data.driver.ObjectDriver#write(com.hardcode.gdbms.engine.data.edition.DataWare)
	 */
	public void write(DataWare arg0)
			throws com.hardcode.gdbms.engine.data.driver.DriverException {
		// TODO Auto-generated method stub

	}

	private void getTableEPSG() {
		try {
			Statement stAux = conn.createStatement();

			String sql = "SELECT SRID(" + getLyrDef().getFieldGeometry() + ") FROM " + getTableName()
					+ " LIMIT 1;";
			ResultSet rs = stAux.executeQuery(sql);
			rs.next();
			originalEPSG = "" + rs.getInt(1);
			rs.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public String getSqlTotal() {
		return sqlTotal;
	}

	/**
	 * @return Returns the completeWhere.
	 */
	public String getCompleteWhere() {
		return completeWhere;
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.drivers.VectorialDatabaseDriver#getFeatureIterator(java.awt.geom.Rectangle2D,
	 *      java.lang.String, java.lang.String[])
	 */
	public IFeatureIterator getFeatureIterator(Rectangle2D r, String strEPSG,
			String[] alphaNumericFieldsNeeded) throws DriverException {
		if (workingArea != null)
			r = r.createIntersection(workingArea);

		String strAux = getGeometryField(getLyrDef().getFieldGeometry());
		boolean found = false;
		if (alphaNumericFieldsNeeded != null) {
			for (int i = 0; i < alphaNumericFieldsNeeded.length; i++) {
				strAux = strAux + ", " + alphaNumericFieldsNeeded[i];
				if (alphaNumericFieldsNeeded[i]
						.equals(getLyrDef().getFieldID()))
					found = true;
			}
		}
		// Nos aseguramos de pedir siempre el campo ID
		if (found == false)
			strAux = strAux + ", " + getLyrDef().getFieldID();

		String sqlProv = "SELECT " + strAux + " FROM "
				+ getLyrDef().getTableName() + " ";
				// + getLyrDef().getWhereClause();

		String sqlAux;
		sqlAux = sqlProv + getCompoundWhere(r, strEPSG);

		System.out.println("SqlAux getFeatureIterator = " + sqlAux);

		return getFeatureIterator(sqlAux);
	}

	public boolean isWritable() {
		// TODO Auto-generated method stub
		return true;
	}


}
