package org.gvsig.rasterTools.saveRaster.ui.main;

import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JComboBox;

import java.awt.Color;
import java.awt.FlowLayout;

public class InputSizeDataPanel extends JPanel {

	private JPanel pBorder = null;
	private JLabel lWidth = null;
	private JTextField tWidth = null;
	private JLabel lHeight = null;
	private JTextField tHeight = null;
	private JComboBox cbMeasureType = null;
	private JPanel jPanel = null;

	/**
	 * This is the default constructor
	 */
	public InputSizeDataPanel() {
		super();
		initialize();
		this.setActive(false);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		FlowLayout flowLayout = new FlowLayout();
		flowLayout.setHgap(0);
		flowLayout.setAlignment(java.awt.FlowLayout.LEFT);
		flowLayout.setVgap(0);
		this.setLayout(flowLayout);
		this.setSize(337, 28);
		this.setPreferredSize(new java.awt.Dimension(337,28));
		this.add(getPBorder(), null);
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPBorder() {
		if (pBorder == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout1.setHgap(0);
			flowLayout1.setVgap(4);
			lHeight = new JLabel();
			lHeight.setText("Alto:");
			lWidth = new JLabel();
			lWidth.setText("Ancho:");
			pBorder = new JPanel();
			pBorder.setLayout(flowLayout1);
			pBorder.setPreferredSize(new java.awt.Dimension(337,28));
			pBorder.add(lWidth, null);
			pBorder.add(getTWidth(), null);
			pBorder.add(lHeight, null);
			pBorder.add(getTHeight(), null);
			pBorder.add(getJPanel(), null);
		}
		return pBorder;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getTWidth() {
		if (tWidth == null) {
			tWidth = new JTextField();
			tWidth.setPreferredSize(new java.awt.Dimension(85,19));
		}
		return tWidth;
	}

	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getTHeight() {
		if (tHeight == null) {
			tHeight = new JTextField();
			tHeight.setPreferredSize(new java.awt.Dimension(85,19));
		}
		return tHeight;
	}

	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	public JComboBox getCbMeasureType() {
		if (cbMeasureType == null) {
			cbMeasureType = new JComboBox();
			cbMeasureType.setPreferredSize(new java.awt.Dimension(65,24));
			cbMeasureType.addItem("Pixels");
			cbMeasureType.addItem("Cms");
			cbMeasureType.addItem("Mms");
			cbMeasureType.addItem("Mts");
			cbMeasureType.addItem("Inches");
		}
		return cbMeasureType;
	}

	/**
	 * Activa o desactiva las cajas de texto con los datos
	 * ancho y alto.
	 * @param active true activa los JTextBox y false los desactiva
	 */
	public void setActive(boolean active){
		Color backgroudColor = getBackground();
		
		this.getTWidth().setEnabled(active);
		this.getTHeight().setEnabled(active);
		this.getCbMeasureType().setEnabled(active);
		
		if(active){
			getTWidth().setBackground(Color.white);
			getTHeight().setBackground(Color.white);
		}else{
			getTWidth().setBackground(backgroudColor);
			getTHeight().setBackground(backgroudColor);
		}
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			FlowLayout flowLayout2 = new FlowLayout();
			flowLayout2.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout2.setVgap(0);
			flowLayout2.setHgap(14);
			jPanel = new JPanel();
			jPanel.setLayout(flowLayout2);
			jPanel.setPreferredSize(new java.awt.Dimension(82,28));
			jPanel.add(getCbMeasureType(), null);
		}
		return jPanel;
	}
	
	/**
	 * Obtiene la etiqueta con el valor ancho
	 * @return
	 */
	public JLabel getLWidth(){
		return this.lWidth;
	}
	
	/**
	 * Obtiene la etiqueta con el valor alto
	 * @return
	 */
	public JLabel getLHeight(){
		return this.lHeight;
	}
}
