/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.gvsig.rasterTools.saveRaster.ui.properties;

import java.awt.BorderLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.FlowLayout;
import javax.swing.JButton;


/**
 * Panel que contiene la barra de progreso para salvar a raster
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class ProgressSaveRasterPanel extends JPanel {
    final private static long serialVersionUID = -3370601314380922368L;
    private JPanel pGeneral = null;
    private JProgressBar jProgressBar = null;

    private JPanel pBar = null;
    private JPanel pCancel = null;
	private JPanel pCurrentElement = null;
	private JPanel pWait = null;
	private JLabel lWait = null;
	private JButton bCancel = null;
	private JLabel lCurrentElement = null;
	private JPanel pPercent = null;
	private JLabel lPercent = null;
	
    /**
     * This method initializes
     *
     */
    public ProgressSaveRasterPanel() {
        super();
        initialize();
    }

    /**
     * This method initializes this
     *
     * @return void
     */
    private void initialize() {
        this.setSize(375, 130);
        this.setPreferredSize(new java.awt.Dimension(364,125));
        this.add(getPGeneral(), null);
    }

    /**
     * This method initializes jPanel
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPGeneral() {
        if (pGeneral == null) {
            GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
            gridBagConstraints3.gridx = 0;
            gridBagConstraints3.gridy = 0;
            GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
            gridBagConstraints21.gridx = 0;
            gridBagConstraints21.gridy = 2;
            GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
            gridBagConstraints11.gridx = 0;
            gridBagConstraints11.gridy = 3;
            GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
            gridBagConstraints1.gridx = 0;
            gridBagConstraints1.ipadx = -6;
            gridBagConstraints1.gridy = 1;
            pGeneral = new JPanel();
            pGeneral.setLayout(new GridBagLayout());
            pGeneral.setPreferredSize(new java.awt.Dimension(360,120));
            pGeneral.add(getPBar(), gridBagConstraints1);
            pGeneral.add(getPCancel(), gridBagConstraints11);
            pGeneral.add(getPCurrentElement(), gridBagConstraints21);
            pGeneral.add(getPWait(), gridBagConstraints3);
        }

        return pGeneral;
    }

    /**
     * This method initializes jProgressBar
     *
     * @return javax.swing.JProgressBar
     */
    public JProgressBar getJProgressBar() {
        if (jProgressBar == null) {
            jProgressBar = new JProgressBar();
            jProgressBar.setVisible(true);
            jProgressBar.show();
            jProgressBar.setValue(0);
            jProgressBar.setPreferredSize(new java.awt.Dimension(350, 25));
        }

        return jProgressBar;
    }

    /**
     * This method initializes jPanel2
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPBar() {
        if (pBar == null) {
            pBar = new JPanel();
            pBar.add(getJProgressBar(), null);
        }

        return pBar;
    }

    /**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPCancel() {
		if (pCancel == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setAlignment(java.awt.FlowLayout.CENTER);
			pCancel = new JPanel();
			pCancel.setLayout(flowLayout1);
			pCancel.setPreferredSize(new java.awt.Dimension(350,30));
			pCancel.add(getBCancel(), null);
		}
		return pCancel;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPCurrentElement() {
		if (pCurrentElement == null) {
			lCurrentElement = new JLabel();
			lCurrentElement.setText("");
			lCurrentElement.setPreferredSize(new java.awt.Dimension(340,15));
			FlowLayout flowLayout2 = new FlowLayout();
			flowLayout2.setAlignment(java.awt.FlowLayout.LEFT);
			pCurrentElement = new JPanel();
			pCurrentElement.setLayout(flowLayout2);
			pCurrentElement.setPreferredSize(new java.awt.Dimension(350,25));
			pCurrentElement.add(lCurrentElement, null);
		}
		return pCurrentElement;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPWait() {
		if (pWait == null) {
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 1;
			gridBagConstraints2.gridy = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new java.awt.Insets(2,2,2,2);
			gridBagConstraints.gridy = 0;
			gridBagConstraints.gridx = 0;
			lWait = new JLabel();
			lWait.setText("Por favor, espere,...");
			pWait = new JPanel();
			pWait.setLayout(new GridBagLayout());
			pWait.setPreferredSize(new java.awt.Dimension(350,25));
			pWait.add(lWait, gridBagConstraints);
			pWait.add(getPPercent(), gridBagConstraints2);
		}
		return pWait;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	public JButton getBCancel() {
		if (bCancel == null) {
			bCancel = new JButton();
			bCancel.setPreferredSize(new java.awt.Dimension(110,20));
			bCancel.setText("Cancelar");
		}
		return bCancel;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPPercent() {
		if (pPercent == null) {
			lPercent = new JLabel();
			lPercent.setText("0%");
			lPercent.setPreferredSize(new java.awt.Dimension(35,15));
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(java.awt.FlowLayout.RIGHT);
			pPercent = new JPanel();
			pPercent.setLayout(flowLayout);
			pPercent.setPreferredSize(new java.awt.Dimension(230,25));
			pPercent.add(lPercent, null);
		}
		return pPercent;
	}
	
	/**
	 * Obtiene la etiqueta del mensaje de espera
	 * @return JLabel que representa la etiqueta del mensaje de espera
	 */
	public JLabel getLabelWait(){
		return lWait;
	}
	
	/**
	 * Obtiene la etiqueta que marca el porcentaje
	 * @return JLabel que representa la etiqueta que marca el porcentaje
	 */
	public JLabel getLabelPercent(){
		return lPercent;
	}
	
	/**
	 * Obtiene la etiqueta del elemento actualmente analizado
	 * @return JLabel que representa la etiqueta del elemento actualmente analizado
	 */
	public JLabel getLabelCurrentElement(){
		return lCurrentElement;
	}
	
} //  @jve:decl-index=0:visual-constraint="10,10"
