package com.iver.cit.gvsig.gui.panels;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JCheckBox;
import javax.swing.JPanel;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.gui.wizards.WFSWizardData;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: WFSAreaPanel.java,v 1.1.2.2 2006/11/17 11:28:45 ppiqueras Exp $
 * $Log: WFSAreaPanel.java,v $
 * Revision 1.1.2.2  2006/11/17 11:28:45  ppiqueras
 * Corregidos bugs y añadida nueva funcionalidad.
 *
 * Revision 1.1  2006/10/10 12:55:06  jorpiell
 * Se ha aadido el soporte de features complejas
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class WFSAreaPanel extends JPanel{
	private WFSWizardData data = null;
	private WFSParamsPanel parent = null;
	private JCheckBox checkBCoordinates = null;
	private JCheckBox checkBView = null;
		
	/**
	 * This method initializes
	 *
	 */
	public WFSAreaPanel(WFSParamsPanel parent) {
		super();
		this.parent = parent;
		initialize();
	}

	/**
	 * This method initializes this
	 *
	 */
	private void initialize() {
		this.setLayout(null);
		this.setBounds(5, 17, 464, 374);
		this.setBorder(javax.swing.BorderFactory.createTitledBorder(
				null, PluginServices.getText(this, "select_area"),
				javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
				javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
		this.add(getCheckBCoordinates(), null);
		this.add(getCheckBView(), null);
	}	

	/**
	 * This method initializes CbCoordinates	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getCheckBCoordinates() {
		if (checkBCoordinates == null) {
			checkBCoordinates = new JCheckBox();
			checkBCoordinates.setBounds(new java.awt.Rectangle(6,19,445,20));
			checkBCoordinates.setText(PluginServices.getText(this,"select_coordinates_manually"));
			checkBCoordinates.addItemListener(new CheckBoxListener("manual"));
		}
		return checkBCoordinates;
	}

	/**
	 * This method initializes checkBview	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getCheckBView() {
		if (checkBView == null) {
			checkBView = new JCheckBox();
			checkBView.setBounds(new java.awt.Rectangle(6,100,442,20));
			checkBView.setText(PluginServices.getText(this,"select_coordinates_using_view"));
			checkBView.addItemListener(new CheckBoxListener("view"));
		}
		return checkBView;
	}

	private class CheckBoxListener implements ItemListener{
		private String comboName = null;
		
		private CheckBoxListener(String comboName){
			this.comboName = comboName;
		}
		
		/*
		 *  (non-Javadoc)
		 * @see java.awt.event.ItemListener#itemStateChanged(java.awt.event.ItemEvent)
		 */
		public void itemStateChanged(ItemEvent e) {
			if (comboName.equals("manual")){
				if (getCheckBCoordinates().isSelected()){
					getCheckBView().setSelected(false);
				}
			}else if(comboName.equals("view")){
				if (getCheckBView().isSelected()){
					getCheckBCoordinates().setSelected(false);
				}
			}
			
		}
		
	}

	
}
