package org.cresques.ui;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JButton;
import javax.swing.JPanel;

import org.cresques.i18n.Messages;
import org.cresques.ui.raster.IResize;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: NewDialogPanel.java,v 1.1.2.1 2006/12/27 08:49:12 maquerol Exp $
 * $Log: NewDialogPanel.java,v $
 * Revision 1.1.2.1  2006/12/27 08:49:12  maquerol
 * Intoduccin del NewDialogPanel para solucionar problemas con las dimensiones del panel.
 *
 * Revision 1.1  2006/12/21 12:52:54  maquerol
 * Panel NewDialogPanel
 *
 *
 */
/**
 * @author Miguel ngel Querol Carratal <querol_mig@gva.es>
 */
public class NewDialogPanel extends JPanel{

	
	private int						wPanel = 300, hPanel = 200;
	private int						wButton = wPanel - 20, hButton = 25;
	private int						wTab = wButton, hTab = hPanel - hButton - 10;
	private int						wContent = wTab - 4, hContent = hTab - 10;
	private int						wButtonContainer = 137, hButtonContainer = 28;
	
	
	private JPanel					tabPane = null;
	private JPanel					pButton = null;
	private JButton					cancelButton = null;
	private JButton					acceptButton = null;
	protected JPanel				contentPane = null;
	private JPanel pButtonContainer = null;
	
	
	
	/**
	 * This is the default constructor
	 */
	public NewDialogPanel(boolean init) {
		if (init)
			initialize();
	}
	
	public NewDialogPanel(){
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.insets = new java.awt.Insets(5,0,0,0);
		gridBagConstraints1.gridy = 1;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		this.setLayout(new GridBagLayout());
		this.setSize(300, 200);
		this.add(getTabPanel(), gridBagConstraints);
		this.add(getPButton(), gridBagConstraints1);
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	protected JPanel getTabPanel() {
		if (tabPane == null) {
			tabPane = new JPanel();
			tabPane.setLayout(new FlowLayout());
			tabPane.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
			tabPane.setPreferredSize(new Dimension(wTab, hTab));
			tabPane.add(getContentPanel(), null);
		}
		return tabPane;
	}

	
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	protected JPanel getContentPanel() {
		if (contentPane == null) {
			contentPane = new JPanel();
			contentPane.setPreferredSize(new java.awt.Dimension(wContent,hContent));
		}
		return contentPane;
	}
	
	
	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPButton() {
		if (pButton == null) {
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setHgap(0);
			flowLayout.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout.setVgap(0);
			pButton = new JPanel();
			pButton.setLayout(flowLayout);
			pButton.setPreferredSize(new Dimension(wButton, hButton));
			//
			pButton.add(getPButtonContainer(), null);
			//pButton.add(getCancelButton(), null);
		}
		return pButton;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	public JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton("Cancelar");
			cancelButton.setText(Messages.getText("Cancelar"));
		}
		return cancelButton;
	}

	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	public JButton getAcceptButton() {
		if (acceptButton == null) {
			acceptButton = new JButton("Aceptar");
			acceptButton.setText(Messages.getText("Aceptar"));
		}
		return acceptButton;
	}

	public void setComponentSize(int w, int h) {
		int						wPanel = w, hPanel = h;
		int						wButton = wPanel - 20, hButton = 25;
		int						wTab = wButton, hTab = hPanel - hButton - 10;
		int						wContent = wTab - 4, hContent = hTab - 10;
		
		this.setSize(wPanel, hPanel);
		getPButton().setPreferredSize(new Dimension(wButton, hButton));
		getTabPanel().setPreferredSize(new Dimension(wTab, hTab));
		getContentPanel().setPreferredSize(new Dimension(wContent, hContent));
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPButtonContainer() {
		if (pButtonContainer == null) {
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.insets = new java.awt.Insets(0,2,0,0);
			gridBagConstraints3.gridy = 0;
			gridBagConstraints3.gridx = 1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.insets = new java.awt.Insets(0,0,0,2);
			gridBagConstraints2.gridy = 0;
			gridBagConstraints2.gridx = 0;
			pButtonContainer = new JPanel();
			pButtonContainer.setLayout(new GridBagLayout());
			pButtonContainer.setPreferredSize(new Dimension(wButtonContainer, hButtonContainer));
			pButtonContainer.add(getAcceptButton(), gridBagConstraints2);
			pButtonContainer.add(getCancelButton(), gridBagConstraints3);
		}
		return pButtonContainer;
	}

	
	
}
