package com.iver.cit.gvsig.fmap.layers;

import java.awt.geom.Rectangle2D;

import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.core.IFeature;
import com.iver.cit.gvsig.fmap.drivers.DBLayerDefinition;
import com.iver.cit.gvsig.fmap.drivers.IFeatureIterator;

public interface ISpatialDB extends ReadableVectorial {

	/**
	 * @return devuelve la Conexin a la base de datos, para que
	 * el usuario pueda hacer la consulta que quiera, si lo desea.
	 * Por ejemplo, esto puede ser til para abrir un cuadro de dialogo
	 * avanazado y lanzar peticiones del tipo "Devuelveme un buffer
	 * a las autopistas", y con el resultset que te venga, escribir
	 * un shape, o cosas as.
	 */
	/* public Connection getConnection()
	 {
	 return ((VectorialDatabaseDriver)driver).getConnection();
	 }*/
	/* public IFeatureIterator getFeatureIterator(String sql) throws DriverException
	 {
	 return ((VectorialDatabaseDriver)driver).getFeatureIterator(sql);
	 }*/
	public IFeatureIterator getFeatureIterator(Rectangle2D r, String strEPSG)
			throws DriverException;

	public IFeatureIterator getFeatureIterator(Rectangle2D r, String strEPSG,
			String[] alphaNumericFieldsNeeded) throws DriverException;

	public DBLayerDefinition getLyrDef();

	public int getRowIndexByFID(IFeature feat);

}