package com.iver.cit.gvsig.fmap.layers;

public interface LayerDrawingListener {
    /**
     * Informs that a layer will be draw.
     * @param e
     * @throws CancelationException Si se quiere cancelar la operacin. El
     *         mensaje de la excepcin es el que se mostrar al usuario en su
     *         caso
     */
    void beforeLayerDraw(LayerDrawEvent e) throws CancelationException;
    

    /**
     * Informs that a layer has been drawn.
     * @param e
     * @throws CancelationException Si se quiere cancelar la operacin. El
     *         mensaje de la excepcin es el que se mostrar al usuario en su
     *         caso
     */

    void afterLayerDraw(LayerDrawEvent e) throws CancelationException;
    
    /**
     * this event is thrown before the graphics layer is draw.
     * @param e
     * @throws CancelationException
     */
    void beforeGraphicLayerDraw(LayerDrawEvent e) throws CancelationException;
    

    /**
     * Like afterTrackingLayerDraw 
     * @param e
     * @throws CancelationException
     */
    void afterLayerGraphicDraw(LayerDrawEvent e) throws CancelationException;
    

}
