/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.tools.Events;

import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;


/**
 * Evento de un punto sobre la vista.
 *
 * @author Vicente Caballero Navarro
 */
public class PointEvent {
	private Point2D p;
	private MouseEvent e;

	/**
	 * Crea un nuevo PointEvent.
	 *
	 * @param p Punto.
	 */
	public PointEvent(Point2D p, MouseEvent e) {
		this.p = p;
		this.e = e;
	}

	/**
	 * Returns the point in the MapContext where the mouse was clicked. Notice that
	 * this is not the point in the screen but it is the world's point.
	 *
	 * @return Punto.
	 */
	public Point2D getPoint() {
		return p;
	}

	/**
	 * Inserta el punto.
	 *
	 * @param p Punto.
	 */
	public void setPoint(Point2D p) {
		this.p = p;
	}

	/**
	 * Obtiene el evento de bajo nivel que produjo
	 * este evento
	 *
	 * @return DOCUMENT ME!
	 */
	public MouseEvent getEvent() {
		return e;
	}
}
