/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.tools.Listeners;

import com.iver.cit.gvsig.fmap.tools.BehaviorException;
import com.iver.cit.gvsig.fmap.tools.Events.MeasureEvent;


/**
 * Interfaz de listener de medida.
 *
 * @author Vicente Caballero Navarro
 */
public interface PolylineListener extends ToolListener {
	/**
	 * Invocado cuando el usuario mueve el ratn cambiando as la posicin del
	 * ltimo punto de la polilnea
	 *
	 * @param event MeasureEvent.
	 *
	 * @throws BehaviorException se lanza cuando falla la herramienta.
	 */
	public void points(MeasureEvent event) throws BehaviorException;

	/**
	 * Invocado cuando el usuario hace click y fija un punto  de la polilinea
	 *
	 * @param event MeasureEvent.
	 *
	 * @throws BehaviorException se lanza cuando falla la herramienta.
	 */
	public void pointFixed(MeasureEvent event) throws BehaviorException;

	/**
	 * Invocado cuando el usuario hace doble click y da por finalizada el
	 * dibujado de la polilnea
	 *
	 * @param event MeasureEvent.
	 *
	 * @throws BehaviorException se lanza cuando falla la herramienta.
	 */
	public void polylineFinished(MeasureEvent event) throws BehaviorException;
}
