package com.hardcode.gdbms.engine.data.driver;

import com.hardcode.gdbms.engine.spatial.Geometry;

import java.awt.geom.Rectangle2D;


/**
 * Driver to access spatial data sources
 */
public interface SpatialDriver {
    /**
     * Gets the full extent of the data accessed
     *
     * @return Rectangle2D
     *
     * @throws DriverException if the operation fails
     */
    public Rectangle2D getFullExtent() throws DriverException;

    /**
     * gets the rowIndex-th geometry
     *
     * @param rowIndex index of the geometry to be retrieved
     *
     * @return Gemetry
     *
     * @throws DriverException If the operation fails
     */
    public Geometry getGeometry(long rowIndex) throws DriverException;

    /**
     * DOCUMENT ME!
     *
     * @param rowIndex DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     *
     * @throws DriverException DOCUMENT ME!
     */
    public com.vividsolutions.jts.geom.Geometry getJTSGeometry(long rowIndex)
        throws DriverException;
}
